<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: Socket.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Socket.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Socket.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Mar 5, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_SOCKET_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_SOCKET_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;sdkconfig.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;mbedtls/platform.h&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;mbedtls/ctr_drbg.h&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;mbedtls/debug.h&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;mbedtls/entropy.h&gt;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;mbedtls/error.h&gt;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;mbedtls/net.h&gt;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;mbedtls/ssl.h&gt;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;lwip/inet.h&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;lwip/sockets.h&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#undef accept</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#undef bind</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#undef close</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#undef connect</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#undef listen</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#undef read</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#undef recv</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#undef send</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#undef write</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &lt;streambuf&gt;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &lt;cstdio&gt;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;cstring&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;exception&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#if CONFIG_CXX_EXCEPTIONS != 1</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#error &quot;C++ exception handling must be enabled within make menuconfig. See Compiler Options &gt; Enable C++ Exceptions.&quot;</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="classSocketException.html">   45</a></span>&#160;<span class="keyword">class </span><a class="code" href="classSocketException.html">SocketException</a>: <span class="keyword">public</span> std::exception {</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <a class="code" href="classSocketException.html">SocketException</a>(<span class="keywordtype">int</span> myErrno);</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordtype">int</span> m_errno;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;};</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="classSocket.html">   62</a></span>&#160;<span class="keyword">class </span><a class="code" href="classSocket.html">Socket</a> {</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <a class="code" href="classSocket.html">Socket</a>();</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classSocket.html">Socket</a>();</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <a class="code" href="classSocket.html">Socket</a> <a class="code" href="classSocket.html#a3f749d9a206e48a875e8c24f29500a93">accept</a>();</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">static</span> std::string <a class="code" href="classSocket.html#aa0aa0b437ca534447e335b58e8a30254">addressToString</a>(<span class="keyword">struct</span> sockaddr* addr);</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#adc1e8efb9384ac637d42e93008debb6a">bind</a>(uint16_t port, uint32_t address);</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#aef06605c6725958004116983f1a2051f">close</a>();</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#ae537e61bb9f64b0322c6e9c39bb24fde">connect</a>(<span class="keyword">struct</span> in_addr address, uint16_t port);</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#ae537e61bb9f64b0322c6e9c39bb24fde">connect</a>(<span class="keywordtype">char</span>* address, uint16_t port);</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#a788b0d2a4070a64fb38d2c6e6289f96e">createSocket</a>(<span class="keywordtype">bool</span> isDatagram = <span class="keyword">false</span>);</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classSocket.html#ad435a8a36e2759203db8b4b2c67e4e85">setReuseAddress</a>(<span class="keywordtype">bool</span> value);</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#a0bee77d0779e5d3a0f62ef7d37e5033d">setSocketOption</a>(<span class="keywordtype">int</span> option, <span class="keywordtype">void</span>* value, <span class="keywordtype">size_t</span> len);</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#aef6249eaa9b2be5a386f85cb828c2b4a">setTimeout</a>(uint32_t seconds);</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classSocket.html#a6b59f7b6e3be56f4d4a27558bde48e85">getBind</a>(<span class="keyword">struct</span> sockaddr* pAddr);</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#a2ba81037cc4a722e155c7bbbfef58b0d">getFD</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordtype">bool</span> getSSL() <span class="keyword">const</span>;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keywordtype">bool</span> isValid();</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#a893bb9a6107d2139cfb088f0c82ac5ae">listen</a>(uint16_t port, <span class="keywordtype">bool</span> isDatagram = <span class="keyword">false</span>, <span class="keywordtype">bool</span> reuseAddress = <span class="keyword">false</span>);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="keywordtype">bool</span> operator&lt;(<span class="keyword">const</span> <a class="code" href="classSocket.html">Socket</a>&amp; other) <span class="keyword">const</span>;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    std::string readToDelim(std::string delim);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keywordtype">size_t</span>  <a class="code" href="classSocket.html#abeb5751e47f3fa96755aba55d29c300a">receive</a>(uint8_t* data, <span class="keywordtype">size_t</span> length, <span class="keywordtype">bool</span> exact = <span class="keyword">false</span>);</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#afc27706410db610051b84cb3c969daa3">receiveFrom</a>(uint8_t* data, <span class="keywordtype">size_t</span> length, <span class="keyword">struct</span> sockaddr* pAddr);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#ad9757badfe9d9903d07ef7c70279ad77">send</a>(std::string value) <span class="keyword">const</span>;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#ad9757badfe9d9903d07ef7c70279ad77">send</a>(<span class="keyword">const</span> uint8_t* data, <span class="keywordtype">size_t</span> length) <span class="keyword">const</span>;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#ad9757badfe9d9903d07ef7c70279ad77">send</a>(uint16_t value);</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="keywordtype">int</span>  <a class="code" href="classSocket.html#ad9757badfe9d9903d07ef7c70279ad77">send</a>(uint32_t value);</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classSocket.html#a44a41324fbee63de97bdadc7de03bda3">sendTo</a>(<span class="keyword">const</span> uint8_t* data, <span class="keywordtype">size_t</span> length, <span class="keyword">struct</span> sockaddr* pAddr);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classSocket.html#a73d0af1a733ff70a622eac54a997f887">setSSL</a>(<span class="keywordtype">bool</span> sslValue = <span class="keyword">true</span>);</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    std::string <a class="code" href="classSocket.html#a377ac3bcbf52e36dc08bca6ad0c8a97f">toString</a>();</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keywordtype">int</span>  m_sock;     <span class="comment">// The underlying TCP/IP socket</span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordtype">bool</span> m_useSSL;   <span class="comment">// Should we use SSL</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    mbedtls_net_context      m_sslSock;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    mbedtls_entropy_context  m_entropy;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    mbedtls_ctr_drbg_context m_ctr_drbg;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    mbedtls_ssl_context      m_sslContext;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    mbedtls_ssl_config       m_conf;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    mbedtls_x509_crt         m_srvcert;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    mbedtls_pk_context       m_pkey;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="keywordtype">void</span> sslHandshake();</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;};</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classSocketInputRecordStreambuf.html">  108</a></span>&#160;<span class="keyword">class </span><a class="code" href="classSocketInputRecordStreambuf.html">SocketInputRecordStreambuf</a> : <span class="keyword">public</span> std::streambuf {</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <a class="code" href="classSocketInputRecordStreambuf.html#a0ed684a3ce6c98cd806c35fd551937c3">SocketInputRecordStreambuf</a>(<a class="code" href="classSocket.html">Socket</a> socket, <span class="keywordtype">size_t</span> dataLength, <span class="keywordtype">size_t</span> bufferSize = 512);</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    ~<a class="code" href="classSocketInputRecordStreambuf.html">SocketInputRecordStreambuf</a>();</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    int_type <a class="code" href="classSocketInputRecordStreambuf.html#a87d321805e116126cd2ded9e748cd25d">underflow</a>();</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="keywordtype">char</span>*   m_buffer;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <a class="code" href="classSocket.html">Socket</a>  m_socket;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordtype">size_t</span>  m_dataLength;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keywordtype">size_t</span>  m_bufferSize;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keywordtype">size_t</span>  m_sizeRead;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;};</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_SOCKET_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classSocketInputRecordStreambuf_html"><div class="ttname"><a href="classSocketInputRecordStreambuf.html">SocketInputRecordStreambuf</a></div><div class="ttdef"><b>Definition:</b> Socket.h:108</div></div>
<div class="ttc" id="classSocket_html"><div class="ttname"><a href="classSocket.html">Socket</a></div><div class="ttdoc">Encapsulate a socket.</div><div class="ttdef"><b>Definition:</b> Socket.h:62</div></div>
<div class="ttc" id="classSocket_html_a6b59f7b6e3be56f4d4a27558bde48e85"><div class="ttname"><a href="classSocket.html#a6b59f7b6e3be56f4d4a27558bde48e85">Socket::getBind</a></div><div class="ttdeci">void getBind(struct sockaddr *pAddr)</div><div class="ttdoc">Get the bound address.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:225</div></div>
<div class="ttc" id="classSocketException_html"><div class="ttname"><a href="classSocketException.html">SocketException</a></div><div class="ttdef"><b>Definition:</b> Socket.h:45</div></div>
<div class="ttc" id="classSocket_html_a893bb9a6107d2139cfb088f0c82ac5ae"><div class="ttname"><a href="classSocket.html#a893bb9a6107d2139cfb088f0c82ac5ae">Socket::listen</a></div><div class="ttdeci">int listen(uint16_t port, bool isDatagram=false, bool reuseAddress=false)</div><div class="ttdoc">Create a listening socket.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:259</div></div>
<div class="ttc" id="classSocket_html_a73d0af1a733ff70a622eac54a997f887"><div class="ttname"><a href="classSocket.html#a73d0af1a733ff70a622eac54a997f887">Socket::setSSL</a></div><div class="ttdeci">void setSSL(bool sslValue=true)</div><div class="ttdoc">Flag the socket as using SSL.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:510</div></div>
<div class="ttc" id="classSocketInputRecordStreambuf_html_a0ed684a3ce6c98cd806c35fd551937c3"><div class="ttname"><a href="classSocketInputRecordStreambuf.html#a0ed684a3ce6c98cd806c35fd551937c3">SocketInputRecordStreambuf::SocketInputRecordStreambuf</a></div><div class="ttdeci">SocketInputRecordStreambuf(Socket socket, size_t dataLength, size_t bufferSize=512)</div><div class="ttdoc">Create a socket input record streambuf.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:627</div></div>
<div class="ttc" id="classSocket_html_a44a41324fbee63de97bdadc7de03bda3"><div class="ttname"><a href="classSocket.html#a44a41324fbee63de97bdadc7de03bda3">Socket::sendTo</a></div><div class="ttdeci">void sendTo(const uint8_t *data, size_t length, struct sockaddr *pAddr)</div><div class="ttdoc">Send data to a specific address.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:481</div></div>
<div class="ttc" id="classSocket_html_ae537e61bb9f64b0322c6e9c39bb24fde"><div class="ttname"><a href="classSocket.html#ae537e61bb9f64b0322c6e9c39bb24fde">Socket::connect</a></div><div class="ttdeci">int connect(struct in_addr address, uint16_t port)</div><div class="ttdoc">Connect to a partner.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:164</div></div>
<div class="ttc" id="classSocket_html_aef6249eaa9b2be5a386f85cb828c2b4a"><div class="ttname"><a href="classSocket.html#aef6249eaa9b2be5a386f85cb828c2b4a">Socket::setTimeout</a></div><div class="ttdeci">int setTimeout(uint32_t seconds)</div><div class="ttdoc">Socket timeout.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:303</div></div>
<div class="ttc" id="classSocket_html_abeb5751e47f3fa96755aba55d29c300a"><div class="ttname"><a href="classSocket.html#abeb5751e47f3fa96755aba55d29c300a">Socket::receive</a></div><div class="ttdeci">size_t receive(uint8_t *data, size_t length, bool exact=false)</div><div class="ttdoc">Receive data from the partner. Receive data from the socket partner. If exact = false,...</div><div class="ttdef"><b>Definition:</b> Socket.cpp:349</div></div>
<div class="ttc" id="classSocket_html_aa0aa0b437ca534447e335b58e8a30254"><div class="ttname"><a href="classSocket.html#aa0aa0b437ca534447e335b58e8a30254">Socket::addressToString</a></div><div class="ttdeci">static std::string addressToString(struct sockaddr *addr)</div><div class="ttdoc">Convert a socket address to a string representation.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:92</div></div>
<div class="ttc" id="classSocket_html_aef06605c6725958004116983f1a2051f"><div class="ttname"><a href="classSocket.html#aef06605c6725958004116983f1a2051f">Socket::close</a></div><div class="ttdeci">int close()</div><div class="ttdoc">Close the socket.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:135</div></div>
<div class="ttc" id="classSocket_html_a3f749d9a206e48a875e8c24f29500a93"><div class="ttname"><a href="classSocket.html#a3f749d9a206e48a875e8c24f29500a93">Socket::accept</a></div><div class="ttdeci">Socket accept()</div><div class="ttdoc">Accept a new socket.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:57</div></div>
<div class="ttc" id="classSocket_html_adc1e8efb9384ac637d42e93008debb6a"><div class="ttname"><a href="classSocket.html#adc1e8efb9384ac637d42e93008debb6a">Socket::bind</a></div><div class="ttdeci">int bind(uint16_t port, uint32_t address)</div><div class="ttdoc">Bind an address/port to a socket. Specify a port of 0 to have a local port allocated....</div><div class="ttdef"><b>Definition:</b> Socket.cpp:110</div></div>
<div class="ttc" id="classSocket_html_ad435a8a36e2759203db8b4b2c67e4e85"><div class="ttname"><a href="classSocket.html#ad435a8a36e2759203db8b4b2c67e4e85">Socket::setReuseAddress</a></div><div class="ttdeci">void setReuseAddress(bool value)</div><div class="ttdoc">Flag the socket address as re-usable.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:498</div></div>
<div class="ttc" id="classSocket_html_ad9757badfe9d9903d07ef7c70279ad77"><div class="ttname"><a href="classSocket.html#ad9757badfe9d9903d07ef7c70279ad77">Socket::send</a></div><div class="ttdeci">int send(std::string value) const</div><div class="ttdoc">Send a string to the partner.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:457</div></div>
<div class="ttc" id="classSocket_html_a788b0d2a4070a64fb38d2c6e6289f96e"><div class="ttname"><a href="classSocket.html#a788b0d2a4070a64fb38d2c6e6289f96e">Socket::createSocket</a></div><div class="ttdeci">int createSocket(bool isDatagram=false)</div><div class="ttdoc">Create the socket.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:204</div></div>
<div class="ttc" id="classSocket_html_afc27706410db610051b84cb3c969daa3"><div class="ttname"><a href="classSocket.html#afc27706410db610051b84cb3c969daa3">Socket::receiveFrom</a></div><div class="ttdeci">int receiveFrom(uint8_t *data, size_t length, struct sockaddr *pAddr)</div><div class="ttdoc">Receive data with the address.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:400</div></div>
<div class="ttc" id="classSocket_html_a2ba81037cc4a722e155c7bbbfef58b0d"><div class="ttname"><a href="classSocket.html#a2ba81037cc4a722e155c7bbbfef58b0d">Socket::getFD</a></div><div class="ttdeci">int getFD() const</div><div class="ttdoc">Get the underlying socket file descriptor.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:241</div></div>
<div class="ttc" id="classSocketInputRecordStreambuf_html_a87d321805e116126cd2ded9e748cd25d"><div class="ttname"><a href="classSocketInputRecordStreambuf.html#a87d321805e116126cd2ded9e748cd25d">SocketInputRecordStreambuf::underflow</a></div><div class="ttdeci">int_type underflow()</div><div class="ttdoc">Handle the request to read data from the stream but we need more data from the source.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:650</div></div>
<div class="ttc" id="classSocket_html_a377ac3bcbf52e36dc08bca6ad0c8a97f"><div class="ttname"><a href="classSocket.html#a377ac3bcbf52e36dc08bca6ad0c8a97f">Socket::toString</a></div><div class="ttdeci">std::string toString()</div><div class="ttdoc">Get the string representation of this socket.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:614</div></div>
<div class="ttc" id="classSocket_html_a0bee77d0779e5d3a0f62ef7d37e5033d"><div class="ttname"><a href="classSocket.html#a0bee77d0779e5d3a0f62ef7d37e5033d">Socket::setSocketOption</a></div><div class="ttdeci">int setSocketOption(int option, void *value, size_t len)</div><div class="ttdoc">Set the socket option.</div><div class="ttdef"><b>Definition:</b> Socket.cpp:290</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
